<?php
namespace Prontosms\Sms;

class Sender {
	
	public $transport = null;
	public $translit = null;
	public $event = null;
	public $eventName = null;
	
	function __construct($defaultTransportInterface=true,$params=array()) {
		
		if($defaultTransportInterface){
			
			// 
			$classname = \Bitrix\Main\Config\Option::get("prontosms.sms","transport","main","");
			if($classname){
				if(strpos($classname,'.php')!==false) $classname = str_replace(".php","",$classname);
				$classname = ToUpper(substr($classname,0,1)).substr($classname,1);
				$classname = "\\Prontosms\\Sms\\Transport\\".$classname;
				$api = \Bitrix\Main\Config\Option::get("prontosms.sms", "api", "clk.prontosms.ru","");
				$paramsAr = array(
					'login' => ($api ? $api.'||' : '').\Bitrix\Main\Config\Option::get("prontosms.sms","login",""),
					'passw' => \Bitrix\Main\Config\Option::get("prontosms.sms","passw",""),
					'sender' => \Bitrix\Main\Config\Option::get("prontosms.sms","sender_viber","").'|||'.\Bitrix\Main\Config\Option::get("prontosms.sms","sender",""),
					'api_viber'=>\Bitrix\Main\Config\Option::get("prontosms.sms", "api_viber", "clk.prontosms.ru","")
				);
				if(!$paramsAr['sender']) $paramsAr['sender'] = '.|||.';
				$this->setTransport($classname,$paramsAr);
			}
		
		}
		$this->event = 'DEFAULT';
	
	}
	
	public function setTransport($transport,$params){
		if(!class_exists($transport)) return false;
		$this->transport = new $transport($params);
	}
	
	/**
	*     
	* @param string      $phone       
	* @param boolean     $all          true ( ), false ( )
	* @return array                phone -   , check -  (boolean)
	*/
	public function checkPhoneNumber ($phone,$all=true) {
		
		//   
		$phoneFormat = '+'.preg_replace("/[^0-9A-Za-z]/", "", $phone);
		
		//  
		$pattern_world = "/^\+?([87](?!95[4-79]|99[^2457]|907|94[^0]|336|986)([348]\d|9[0-689]|7[0247])\d{8}|[1246]\d{9,13}|68\d{7}|5[1-46-9]\d{8,12}|55[1-9]\d{9}|55119\d{8}|500[56]\d{4}|5016\d{6}|5068\d{7}|502[45]\d{7}|5037\d{7}|50[457]\d{8}|50855\d{4}|509[34]\d{7}|376\d{6}|855\d{8}|856\d{10}|85[0-4789]\d{8,10}|8[68]\d{10,11}|8[14]\d{10}|82\d{9,10}|852\d{8}|90\d{10}|96(0[79]|17[01]|13)\d{6}|96[23]\d{9}|964\d{10}|96(5[69]|89)\d{7}|96(65|77)\d{8}|92[023]\d{9}|91[1879]\d{9}|9[34]7\d{8}|959\d{7}|989\d{9}|97\d{8,12}|99[^4568]\d{7,11}|994\d{9}|9955\d{8}|996[57]\d{8}|9989\d{8}|380[34569]\d{8}|381\d{9}|385\d{8,9}|375[234]\d{8}|372\d{7,8}|37[0-4]\d{8}|37[6-9]\d{7,11}|30[69]\d{9}|34[67]\d{8}|3[12359]\d{8,12}|36\d{9}|38[1679]\d{8}|382\d{8,9})$/";
		//  
		$pattern_sng = "/^((\+?7|8)(?!95[4-79]|99[^2457]|907|94[^0]|336)([348]\d|9[0-689]|7[07])\d{8}|\+?(99[^456]\d{7,11}|994\d{9}|9955\d{8}|996[57]\d{8}|380[34569]\d{8}|375[234]\d{8}|372\d{7,8}|37[0-4]\d{8}))$/";
		
		if($all) {
			$patt = $pattern_world;
		}
		else {
			$patt = $pattern_sng;
		}
		
		if(!preg_match($patt, $phoneFormat)) {
			return array('phone'=>$phoneFormat,'check'=>false);
		}
		
		return array('phone'=>$phoneFormat,'check'=>true);
	
	}
	
	// ,  ,     
	public function sendSms($phones, $MEWSS, $time=0, $sender=false, $prim='', $addHistory=true, $update=false, $error=false) {
			
			
			$arParamsTranslit = array("max_len"=>"1000","change_case"=>"false","replace_space"=>" ","replace_other"=>"","","delete_repeat_replace"=>false,
			"safe_chars"=>'$%&*()_+=-#@!\'"./\\,<>?;:|~`');
			if($this->translit===true) {
				$tm = array();
				if(strpos($MEWSS,'|||')!==false){
					$tm = explode('|||',$MEWSS);
					$MEWSS = $tm[1];
				}
				$MEWSS = \CUtil::translit($MEWSS,"ru",$arParamsTranslit);
				if($tm[0]) $MEWSS = $tm[0].'|||'.$MEWSS;
			}
			
			if(($time==0 || $time<time()) && !$error) {
				$time = 0;
				
				if($this->transport===null){
					$send = new \stdClass();
					$send->error = 'Transport not found';
					$send->error_code = '9998';
				}else{
					$send = $this->transport->_sendSms($phones, $MEWSS, $time, $sender);
				}
				
				if($send->error_code){
					$status = 12;
					if($send->error_code == 6) $status = 9;
					if($send->error_code == 3) $status = 10;
					if($send->error_code == 1) $status = 11;
					return $this->sendSms($phones, $MEWSS, time(), $sender, $prim.', '.$send->error, $addHistory, $update, array('status'=>12, 'send'=>$send));
				}
			}

			if($addHistory) {
				if(!$sender) $sender = \Bitrix\Main\Config\Option::get("prontosms.sms","sender_viber","","").'|||'.\Bitrix\Main\Config\Option::get("prontosms.sms","sender","","");
				if(strpos($sender,'|||')!==false){
				
				}else{
					$sender = \Bitrix\Main\Config\Option::get("prontosms.sms","sender_viber","","").'|||'.$sender;
				}
				if($time==0) {
					$time = time();
					$id = $send->id;
					$status = 2;
				}
				else{
					$id = '-';
					$status = 1;
					if($error) $status = $error['status'];
				}
					$arFields = array(
						'SMSID' => $id,
						'SENDER' => $sender,
						'PHONE' => $phones,
						'TIME_SEND' => \Bitrix\Main\Type\DateTime::createFromTimestamp($time),
						'TIME_STATE' => null,
						'MESS' => $MEWSS,
						'PRIM' => $prim,
						'STATUS'=> $status,
						'EVENT' => $this->event,
						'EVENT_NAME' => $this->eventName
					);
					\Prontosms\Sms\ListTable::add($arFields);
				if(!$error) {
					return $send;
				}
				else{
					return $error['send'];
				}
			}
			
			if ($update) {
				
				if($error) {
					$status = $error['status'];
					$sendid = '-';
				}else{
					$status=2;
					$sendid = $send->id;
				}
				$arData = array(
					"STATUS" => $status,
					"SMSID" => $sendid
				);
				\Prontosms\Sms\ListTable::update(array("ID"=>$update['id']),$arData);
			}
			
			if(!$error) {
				return $send;
			}
			else{
				return $error['send'];
			}
				
	}
	
	public function getBalance(){
		
		$arBalance = array(
			'main' => $this->getBalanceTransport(true),
		);
		
		return $arBalance;
	
	}
	
	//   +  
	public function getAllSender($main=true) {
		
		if($this->transport===null) return false;
		
		$obCache = \Bitrix\Main\Data\Cache::createInstance();
		
		$cache_time = \Bitrix\Main\Config\Option::get("prontosms.sms","cacheotp","86400","");
		$cache_id = 'senders.'.$this->transport_name;
		
		
		if( $obCache->initCache($cache_time,$cache_id,"/prontosms/sms/admin/") )
		{
			$vars = $obCache->GetVars();
		}
		elseif( $obCache->startDataCache()  )
		{
			$vars = $this->transport->_getAllSender();
			
			if(!$vars->error){
				$obCache->endDataCache($vars);
			}else{
				$obCache->abortDataCache();
			}
		}
		return $vars;
		
	}
	
	//    +  
	private function getBalanceTransport($main=true){
		
		if($this->transport===null) return false;
		
		$obCache = \Bitrix\Main\Data\Cache::createInstance();
		$cache_time = \Bitrix\Main\Config\Option::get("prontosms.sms","cachebalance","120","");
		$cache_id = 'balance.'.$this->transport_name;
		
		if( $obCache->initCache($cache_time,$cache_id,"/prontosms/sms/admin/") )
		{
			$vars = $obCache->GetVars();
		}
		elseif( $obCache->startDataCache()  )
		{
			$vars = $this->transport->_getBalance();
			
			if(!$vars->error){
				$obCache->endDataCache($vars);
			}
			else{
				$obCache->abortDataCache();
			}
		}
		return $vars;
	}
	
	//      
	public function getTurnSms() {
		
		$arFilter = array();
		$arFilter["STATUS"] = 1;
		$arFilter["<TIME_SEND"] = \Bitrix\Main\Type\DateTime::createFromTimestamp(time());
		
		$res = \Prontosms\Sms\ListTable::getList(
			array(
				'select' => array('ID','SENDER','PHONE','MESS'),
				'filter' => array($arFilter),
				'limit' => \Bitrix\Main\Config\Option::get("prontosms.sms","limitsms",10,""),
				'order' => array("SORT"=>"DESC")
			)
		);
		while ($data = $res->fetch()){
			usleep(100000); //     10   
			$send = $this->sendSms($data['PHONE'], $data['MESS'], 0, $data['SENDER'], '', false, array('id'=>$data['ID']));
			
		}
	
	}
	
	//    
	public function getStatusSms() {
		
		$arFilter = array();
		$arFilter["STATUS"] = array(0,2,3,6);
		
		$res = \Prontosms\Sms\ListTable::getList(
			array(
				'select' => array('ID','PHONE','SMSID'),
				'filter' => array($arFilter),
				'limit' => (\Bitrix\Main\Config\Option::get("prontosms.sms","limitsms",10,"") * 4)
			)
		);
		
		$arAll = array();
		while ($data = $res->fetch()){
			$arAll[] = $data;
		}
		
		if(!empty($arAll)){
		
		//   
		$allResp = $this->transport->_getStatusSms($arAll);
		foreach($allResp as $resp){
			//     
			if(!$resp->error_code && in_array(intval($resp->status),array(1,2,3,4,5,6,7,8,9,10,11,12))) {
				if(!$resp->last_timestamp) $resp->last_timestamp = time();
				\Prontosms\Sms\ListTable::update(array("ID"=>$resp->baseId),array("STATUS"=>$resp->status,"TIME_STATE"=>\Bitrix\Main\Type\DateTime::createFromTimestamp($resp->last_timestamp)));
			}else{
				if(!$resp->last_timestamp) $resp->last_timestamp = time();
				\Prontosms\Sms\ListTable::update(array("ID"=>$resp->baseId),array("STATUS"=>12,"TIME_STATE"=>\Bitrix\Main\Type\DateTime::createFromTimestamp($resp->last_timestamp)));
			}
		}
		
		}
		
	}
	
}
